<template>
	<v-container>
		<p class="text-center display-1" v-if="toIncomplete">Solicitudes incompletas {{ period }}</p>
		<p class="text-center display-1" v-else>Solicitudes {{ period }}</p>
		<v-row justify="space-between">
			<v-col cols="3">
				<v-btn color="green" block dark v-if="toIncomplete" @click="changeToIncomplete">Solicitudes completadas</v-btn>
				<v-btn color="warning" block dark v-else @click="changeToIncomplete">Solicitudes incompletas</v-btn>
			</v-col>
			<v-col cols="4">
				<v-select
					v-model="typeScholarship"
					label="Seleccione el tipo de beca"
					:items="scholarships"
					outlined
				/>
			</v-col>
		</v-row>
		<v-row>
			<UsersTable/>
		</v-row>
		<v-row justify="center" class="mt-5">
			<v-col cols="12" sm="3">
				<v-btn outlined block color="orange" @click="getConcentred">Obtener concentrado</v-btn>
			</v-col>
		</v-row>
		<Navigation />
	</v-container>
</template>

<script>
import Navigation from "@/components/Navigation";
import UsersTable from "@/components/admin/UsersTable";
import { mapMutations } from "vuex";
import EventBus from "../../bus";
import axios from "axios";

export default {
	name: "Requests",
	components: { Navigation, UsersTable },
	data: () => ({
		date: new Date(),
		typeScholarship: "",
		toIncomplete: false,
		scholarships: [
			"Talento especial",
			"Excelencia académica",
			"Mejora académica",
			"Labsol"
		]
	}),
	watch: {
		typeScholarship: function(value) {
			EventBus.$emit("changeSelectScholarship", { value, toIncomplete: this.toIncomplete });
		}
	},
	computed: {
		period() {
			if (this.date.getMonth() + 1 <= 6) {
				return `Enero - Junio ${this.date.getFullYear()}`;
			} else {
				return `Agosto - Diciembre ${this.date.getFullYear()}`;
			}
		}
	},
	methods: {
		...mapMutations(["saveUserData"]),

		// Obtiene el concentrado de las solicitudes
		async getConcentred() {
			try {
				const response = await axios.get("/getXLSX", {
					responseType: "blob",
					headers: {
						Accept: "application/vnd.ms-excel",
						Authorization: sessionStorage.getItem("token")
					}
				});
				const url = window.URL.createObjectURL(
					new Blob([response.data])
				);
				const link = document.createElement("a");
				link.href = url;
				link.setAttribute("download", "Concentrado.xlsx");
				document.body.appendChild(link);
				link.click();
			} catch (error) {}
		},
		changeToIncomplete(){
			this.toIncomplete = !this.toIncomplete;
			this.typeScholarship = "";
			EventBus.$emit("cleanUsersTable");
		}
	},
	created() {
		this.saveUserData();
	}
};
</script>
